local Sapper_Version = "v1.1.0";
local Sapper_Mark = true;
local Sapper_SappedName = "";
local Sapper_BlindedName1 = "";
local Sapper_BlindedName2 = "";

function Sapper_OnLoad()
	if UnitClass("player") ~= "Rogue" then
		Sapper_Message("You are not a rogue. Sapper "..Sapper_Version.." Not Loaded");
	else
		Sapper_Message("Sapper "..Sapper_Version.." Loaded");
		this:RegisterEvent("UNIT_AURA");
		this:RegisterEvent("UNIT_COMBAT");
		this:RegisterEvent("CHAT_MSG_SPELL_PERIODIC_CREATURE_DAMAGE");
		this:RegisterEvent("CHAT_MSG_SPELL_PERIODIC_HOSTILEPLAYER_DAMAGE");
		this:RegisterEvent("CHAT_MSG_SPELL_PERIODIC_FRIENDLYPLAYER_DAMAGE");
		this:RegisterEvent("CHAT_MSG_SPELL_AURA_GONE_OTHER");
		this:RegisterEvent("CHAT_MSG_SPELL_BREAK_AURA");
	end
end

function Sapper_Message(msg)
	DEFAULT_CHAT_FRAME:AddMessage("|cff560000<|r|cff680000S|r|cff9c0000a|r|cffce0000p|r|cffce0000p|r|cff9c0000e|r|cff680000r|r|cff560000>|r |cff680000"..msg.."|r");
end

function Sapper_Output(msg)
	local chatType = "PARTY";
	if UnitInRaid("player") then
		chatType = "RAID";
	end
	SendChatMessage(msg, chatType);
	SendChatMessage(msg, "BATTLEGROUND");
end

function Sapper_OnEvent(event)
	--Target Sapped
	if (((event == "CHAT_MSG_SPELL_PERIODIC_CREATURE_DAMAGE") or (event == "CHAT_MSG_SPELL_PERIODIC_FRIENDLYPLAYER_DAMAGE") or (event == "CHAT_MSG_SPELL_PERIODIC_HOSTILEPLAYER_DAMAGE")) and (string.sub(arg1, -20, -1) == "is afflicted by Sap.") and (UnitName("target") == string.sub(arg1, 1, -22))) then
		Sapper_SappedName = string.sub(arg1, 1, -22);
		Sapper_Message(Sapper_SappedName.." Sapped!");
		Sapper_Output(Sapper_SappedName.." has been sapped!");
		--Marks the Sapped target with a red X
		if (IsRaidLeader() or IsRaidOfficer() or IsPartyLeader()) and Sapper_Mark then
			SetRaidTarget("target", 7);
			Sapper_Output("Red X Placed over "..Sapper_SappedName.."'s head.");
		end
	end
	--Sap Faded
	if ((event == "CHAT_MSG_SPELL_AURA_GONE_OTHER") and (arg1 == "Sap fades from "..Sapper_SappedName..".")) then
		Sapper_Message("Sap faded from "..Sapper_SappedName);
		Sapper_Output("Sap has faded from "..Sapper_SappedName.."!");
		Sapper_SappedName = "";
	end
	--Target Blinded
	if (((event == "CHAT_MSG_SPELL_PERIODIC_CREATURE_DAMAGE") or (event == "CHAT_MSG_SPELL_PERIODIC_FRIENDLYPLAYER_DAMAGE") or (event == "CHAT_MSG_SPELL_PERIODIC_HOSTILEPLAYER_DAMAGE")) and (string.sub(arg1, -22, -1) == "is afflicted by Blind.") and (UnitName("target") == string.sub(arg1, 1, -24))) then
		if Sapper_BlindedName1 ~= "" then
			Sapper_BlindedName1 = string.sub(arg1, 1, -24);
			Sapper_Message(Sapper_BlindedName1b.." Blinded!");
			Sapper_Output(Sapper_BlindedName1.." has been blinded!");
			if (IsRaidLeader() or IsRaidOfficer() or IsPartyLeader()) and Sapper_Mark then
				SetRaidTarget("target", 6);
				Sapper_Output("Blue Square Placed over "..Sapper_BlindedName1.."'s head.");
			end
		else
			Sapper_BlindedName2 = string.sub(arg1, 1, -24);
			Sapper_Message(Sapper_BlindedName2.." Blinded!");
			Sapper_Output(Sapper_BlindedName2.." has been blinded!");
			if (IsRaidLeader() or IsRaidOfficer() or IsPartyLeader()) and Sapper_Mark then
				SetRaidTarget("target", 6);
				Sapper_Output("Blue Square Placed over "..Sapper_BlindedName2.."'s head.");
			end
		end
		PlaySoundFile("Interface\\Addons\\Sapper\\GogglesDoNothing.wav");
	end
	--Blind Faded from Blind 1
	if ((event == "CHAT_MSG_SPELL_AURA_GONE_OTHER") and (arg1 == "Blind fades from "..Sapper_BlindedName1..".")) then
		Sapper_Message("Blind faded from "..Sapper_BlindedName1);
		Sapper_Output("Blind has faded from "..Sapper_BlindedName1.."!");
		Sapper_BlindedName1 = "";
	end
	--Blind Faded from Blind 2
	if ((event == "CHAT_MSG_SPELL_AURA_GONE_OTHER") and (arg1 == "Blind fades from "..Sapper_BlindedName2..".")) then
		Sapper_Message("Blind faded from "..Sapper_BlindedName2);
		Sapper_Output("Blind has faded from "..Sapper_BlindedName2.."!");
		Sapper_BlindedName2 = "";
	end
end